/*
 * Copyright (c) Sun Microsystems, Inc. 1995-1998 All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the SMCC Technology
 *      Development Group at Sun Microsystems, Inc.
 *
 * 4. The name of the Sun Microsystems, Inc nor may not be used to endorse or
 *      promote products derived from this software without specific prior
 *      written permission.
 *
 * SUN MICROSYSTEMS MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS
 * SOFTWARE FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" 
 * without express or implied warranty of any kind. 
 *  
 * These notices must be retained in any copies of any part of this software.
 */

#ifndef _NETINET_PKTSCHED_H
#define	_NETINET_PKTSCHED_H

#pragma ident "@(#)pktsched.h  1.3     98/05/04 SMI"

#include <sys/ioctl.h>
#include <sys/ioccom.h>
#include <sys/dlpi.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _KERNEL

#ifndef DL_IOC_PKTSCHED_INIT
#define DL_IOC_PKTSCHED_INIT            (DLIOC|11)
#define DL_IOC_PKTSCHED_TEARDOWN        (DLIOC|12)
#endif

typedef struct _pkt_sched_cb_ {
	void (*pktsched_cb)(void *, int);
	void *pktsched_cb_arg;
} pkt_sched_cb_t;

extern int pktsched_init(queue_t *q, pkt_sched_cb_t *cb, int *flag,
	kmutex_t *mtx, kcondvar_t *cv);
extern int pktsched_teardown(queue_t *q, int *flag, kmutex_t *mtx,
	kcondvar_t *cv);

#endif

#ifdef __cplusplus
}
#endif
#endif /* !_NETINET_CBQ_H */
